diff --git a/src/qmplay2/opengl/Qt4OpenGLCompat.hpp b/src/qmplay2/opengl/Qt4OpenGLCompat.hpp
new file mode 100644
index 00000000..e2102aba
--- /dev/null
+++ b/src/qmplay2/opengl/Qt4OpenGLCompat.hpp
@@ -0,0 +1,248 @@
+/*
+    Qt4 OpenGL Compatibility Layer for QMPlay2
+
+    This header provides compatibility mappings from Qt5+ OpenGL API to Qt4 equivalents.
+    Targets: macOS 10.6.8 PowerPC with OpenGL 2.0
+*/
+
+#pragma once
+
+#include <QtOpenGL/QGLWidget>
+#include <QtOpenGL/QGLShaderProgram>
+#include <QtOpenGL/QGLFramebufferObject>
+#include <QtOpenGL/QGLContext>
+#include <QtOpenGL/QGLFormat>
+
+#include <OpenGL/gl.h>
+#include <OpenGL/glext.h>
+
+// Qt5+ uses QOpenGLShaderProgram, Qt4 uses QGLShaderProgram
+#define QOpenGLShaderProgram QGLShaderProgram
+#define QOpenGLShader QGLShader
+
+// Qt5+ uses QOpenGLContext, Qt4 uses QGLContext
+#define QOpenGLContext QGLContext
+
+// Qt5+ uses QOpenGLWidget, Qt4 uses QGLWidget
+#define QOpenGLWidget QGLWidget
+
+// Qt5+ uses QOpenGLFramebufferObject, Qt4 uses QGLFramebufferObject
+#define QOpenGLFramebufferObject QGLFramebufferObject
+
+// Qt5+ uses QOpenGLFormat, Qt4 uses QGLFormat
+#define QOpenGLFormat QGLFormat
+
+// Qt5+ QOpenGLFunctions equivalent in Qt4
+// In Qt4, OpenGL functions are accessed directly or through QGLContext::getProcAddress()
+class QOpenGLFunctions
+{
+public:
+    inline void initializeOpenGLFunctions() {}
+
+    // These are standard OpenGL 2.0 functions available directly
+    inline void glActiveTexture(GLenum texture) { ::glActiveTexture(texture); }
+    inline void glAttachShader(GLuint program, GLuint shader) { ::glAttachShader(program, shader); }
+    inline void glBindBuffer(GLenum target, GLuint buffer) { ::glBindBuffer(target, buffer); }
+    inline void glBindTexture(GLenum target, GLuint texture) { ::glBindTexture(target, texture); }
+    inline void glBlendFunc(GLenum sfactor, GLenum dfactor) { ::glBlendFunc(sfactor, dfactor); }
+    inline void glBufferData(GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage) {
+        ::glBufferData(target, size, data, usage);
+    }
+    inline void glClear(GLbitfield mask) { ::glClear(mask); }
+    inline void glClearColor(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha) {
+        ::glClearColor(red, green, blue, alpha);
+    }
+    inline void glDeleteBuffers(GLsizei n, const GLuint *buffers) { ::glDeleteBuffers(n, buffers); }
+    inline void glDeleteTextures(GLsizei n, const GLuint *textures) { ::glDeleteTextures(n, textures); }
+    inline void glDisable(GLenum cap) { ::glDisable(cap); }
+    inline void glDrawArrays(GLenum mode, GLint first, GLsizei count) { ::glDrawArrays(mode, first, count); }
+    inline void glDrawElements(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices) {
+        ::glDrawElements(mode, count, type, indices);
+    }
+    inline void glEnable(GLenum cap) { ::glEnable(cap); }
+    inline void glFinish() { ::glFinish(); }
+    inline void glFlush() { ::glFlush(); }
+    inline void glGenBuffers(GLsizei n, GLuint *buffers) { ::glGenBuffers(n, buffers); }
+    inline void glGenTextures(GLsizei n, GLuint *textures) { ::glGenTextures(n, textures); }
+    inline GLenum glGetError() { return ::glGetError(); }
+    inline void glGetIntegerv(GLenum pname, GLint *params) { ::glGetIntegerv(pname, params); }
+    inline const GLubyte *glGetString(GLenum name) { return ::glGetString(name); }
+    inline void glPixelStorei(GLenum pname, GLint param) { ::glPixelStorei(pname, param); }
+    inline void glTexImage2D(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height,
+                            GLint border, GLenum format, GLenum type, const GLvoid *pixels) {
+        ::glTexImage2D(target, level, internalformat, width, height, border, format, type, pixels);
+    }
+    inline void glTexParameteri(GLenum target, GLenum pname, GLint param) {
+        ::glTexParameteri(target, pname, param);
+    }
+    inline void glTexSubImage2D(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width,
+                               GLsizei height, GLenum format, GLenum type, const GLvoid *pixels) {
+        ::glTexSubImage2D(target, level, xoffset, yoffset, width, height, format, type, pixels);
+    }
+    inline void glViewport(GLint x, GLint y, GLsizei width, GLsizei height) {
+        ::glViewport(x, y, width, height);
+    }
+};
+
+// Qt5+ QOpenGLExtraFunctions - Maps to OpenGL 2.0+ functions
+// Some of these may need runtime checks on macOS 10.6.8
+class QOpenGLExtraFunctions : public QOpenGLFunctions
+{
+public:
+    // Vertex Buffer Objects (OpenGL 1.5+, available in OpenGL 2.0)
+    inline void glBindBuffer(GLenum target, GLuint buffer) { ::glBindBuffer(target, buffer); }
+    inline void glDeleteBuffers(GLsizei n, const GLuint *buffers) { ::glDeleteBuffers(n, buffers); }
+    inline void glGenBuffers(GLsizei n, GLuint *buffers) { ::glGenBuffers(n, buffers); }
+    inline void glBufferData(GLenum target, GLsizeiptr size, const GLvoid *data, GLenum usage) {
+        ::glBufferData(target, size, data, usage);
+    }
+    inline void glBufferSubData(GLenum target, GLintptr offset, GLsizeiptr size, const GLvoid *data) {
+        ::glBufferSubData(target, offset, size, data);
+    }
+    inline void *glMapBuffer(GLenum target, GLenum access) {
+        return ::glMapBuffer(target, access);
+    }
+    inline GLboolean glUnmapBuffer(GLenum target) {
+        return ::glUnmapBuffer(target);
+    }
+
+    // Pixel Buffer Objects (OpenGL 2.1+, may not be available on all 10.6.8 systems)
+    // These use the same VBO functions with GL_PIXEL_UNPACK_BUFFER target
+
+    // Shader functions (OpenGL 2.0+)
+    inline GLuint glCreateShader(GLenum type) { return ::glCreateShader(type); }
+    inline void glShaderSource(GLuint shader, GLsizei count, const GLchar **string, const GLint *length) {
+        ::glShaderSource(shader, count, string, length);
+    }
+    inline void glCompileShader(GLuint shader) { ::glCompileShader(shader); }
+    inline void glGetShaderiv(GLuint shader, GLenum pname, GLint *params) {
+        ::glGetShaderiv(shader, pname, params);
+    }
+    inline void glGetShaderInfoLog(GLuint shader, GLsizei bufSize, GLsizei *length, GLchar *infoLog) {
+        ::glGetShaderInfoLog(shader, bufSize, length, infoLog);
+    }
+    inline void glDeleteShader(GLuint shader) { ::glDeleteShader(shader); }
+
+    // Program functions (OpenGL 2.0+)
+    inline GLuint glCreateProgram() { return ::glCreateProgram(); }
+    inline void glAttachShader(GLuint program, GLuint shader) { ::glAttachShader(program, shader); }
+    inline void glLinkProgram(GLuint program) { ::glLinkProgram(program); }
+    inline void glUseProgram(GLuint program) { ::glUseProgram(program); }
+    inline void glGetProgramiv(GLuint program, GLenum pname, GLint *params) {
+        ::glGetProgramiv(program, pname, params);
+    }
+    inline void glGetProgramInfoLog(GLuint program, GLsizei bufSize, GLsizei *length, GLchar *infoLog) {
+        ::glGetProgramInfoLog(program, bufSize, length, infoLog);
+    }
+    inline void glDeleteProgram(GLuint program) { ::glDeleteProgram(program); }
+
+    // Uniform functions (OpenGL 2.0+)
+    inline GLint glGetUniformLocation(GLuint program, const GLchar *name) {
+        return ::glGetUniformLocation(program, name);
+    }
+    inline void glUniform1f(GLint location, GLfloat v0) { ::glUniform1f(location, v0); }
+    inline void glUniform1i(GLint location, GLint v0) { ::glUniform1i(location, v0); }
+    inline void glUniform2f(GLint location, GLfloat v0, GLfloat v1) { ::glUniform2f(location, v0, v1); }
+    inline void glUniform3f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2) {
+        ::glUniform3f(location, v0, v1, v2);
+    }
+    inline void glUniform4f(GLint location, GLfloat v0, GLfloat v1, GLfloat v2, GLfloat v3) {
+        ::glUniform4f(location, v0, v1, v2, v3);
+    }
+
+    // Vertex Attribute functions (OpenGL 2.0+)
+    inline GLint glGetAttribLocation(GLuint program, const GLchar *name) {
+        return ::glGetAttribLocation(program, name);
+    }
+    inline void glVertexAttribPointer(GLuint index, GLint size, GLenum type, GLboolean normalized,
+                                     GLsizei stride, const GLvoid *pointer) {
+        ::glVertexAttribPointer(index, size, type, normalized, stride, pointer);
+    }
+    inline void glEnableVertexAttribArray(GLuint index) { ::glEnableVertexAttribArray(index); }
+    inline void glDisableVertexAttribArray(GLuint index) { ::glDisableVertexAttribArray(index); }
+};
+
+// Qt5+ QOpenGLFunctions_1_5 - Legacy fixed-function pipeline
+// Note: OpenGL 2.0 still supports these, but they're deprecated
+// Only use if not using shaders (legacy path)
+#ifndef QT_OPENGL_ES_2
+class QOpenGLFunctions_1_5
+{
+public:
+    inline bool initializeOpenGLFunctions() { return true; }
+
+    // Matrix functions (deprecated in OpenGL 3.0+, but available in 2.0)
+    inline void glMatrixMode(GLenum mode) { ::glMatrixMode(mode); }
+    inline void glLoadIdentity() { ::glLoadIdentity(); }
+    inline void glOrtho(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top,
+                       GLdouble zNear, GLdouble zFar) {
+        ::glOrtho(left, right, bottom, top, zNear, zFar);
+    }
+
+    // Vertex arrays (deprecated in OpenGL 3.0+, but available in 2.0)
+    inline void glVertexPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer) {
+        ::glVertexPointer(size, type, stride, pointer);
+    }
+    inline void glTexCoordPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer) {
+        ::glTexCoordPointer(size, type, stride, pointer);
+    }
+    inline void glEnableClientState(GLenum array) { ::glEnableClientState(array); }
+    inline void glDisableClientState(GLenum array) { ::glDisableClientState(array); }
+};
+#endif // !QT_OPENGL_ES_2
+
+// Additional macros for Qt5+ compatibility
+#ifndef GL_TEXTURE0
+#define GL_TEXTURE0 0x84C0
+#endif
+
+#ifndef GL_CLAMP_TO_EDGE
+#define GL_CLAMP_TO_EDGE 0x812F
+#endif
+
+// OpenGL 2.0 guarantees these, but define them if missing
+#ifndef GL_ARRAY_BUFFER
+#define GL_ARRAY_BUFFER 0x8892
+#endif
+
+#ifndef GL_ELEMENT_ARRAY_BUFFER
+#define GL_ELEMENT_ARRAY_BUFFER 0x8893
+#endif
+
+#ifndef GL_STATIC_DRAW
+#define GL_STATIC_DRAW 0x88E4
+#endif
+
+#ifndef GL_DYNAMIC_DRAW
+#define GL_DYNAMIC_DRAW 0x88E8
+#endif
+
+#ifndef GL_STREAM_DRAW
+#define GL_STREAM_DRAW 0x88E0
+#endif
+
+// PBO support (OpenGL 2.1+)
+#ifndef GL_PIXEL_UNPACK_BUFFER
+#define GL_PIXEL_UNPACK_BUFFER 0x88EC
+#endif
+
+#ifndef GL_PIXEL_PACK_BUFFER
+#define GL_PIXEL_PACK_BUFFER 0x88EB
+#endif
+
+// Shader types
+#ifndef GL_VERTEX_SHADER
+#define GL_VERTEX_SHADER 0x8B31
+#endif
+
+#ifndef GL_FRAGMENT_SHADER
+#define GL_FRAGMENT_SHADER 0x8B30
+#endif
+
+// Notes for OpenGL 2.0 on macOS 10.6.8:
+// - All OpenGL 2.0 core features are supported
+// - Some OpenGL 2.1+ features (like PBO) may be available as extensions
+// - No geometry shaders (OpenGL 3.2+)
+// - No compute shaders (OpenGL 4.3+)
+// - GLSL version 1.20 is maximum (not 1.30+ or 3.30+)
+// - Core profile not available (only compatibility profile)
diff --git a/src/qmplay2/opengl/shaders/OSD.frag b/src/qmplay2/opengl/shaders/OSD.frag
index 8fda806c..b686c1f4 100644
--- a/src/qmplay2/opengl/shaders/OSD.frag
+++ b/src/qmplay2/opengl/shaders/OSD.frag
@@ -1,3 +1,4 @@
+// GLSL 1.20 for OpenGL 2.0
 varying vec2 vTexCoord;
 uniform sampler2D uTex;
 
diff --git a/src/qmplay2/opengl/shaders/OSD.vert b/src/qmplay2/opengl/shaders/OSD.vert
index 8be7a4ba..2edb9922 100644
--- a/src/qmplay2/opengl/shaders/OSD.vert
+++ b/src/qmplay2/opengl/shaders/OSD.vert
@@ -1,3 +1,4 @@
+// GLSL 1.20 for OpenGL 2.0
 attribute vec4 aPosition;
 attribute vec2 aTexCoord;
 varying vec2 vTexCoord;
diff --git a/src/qmplay2/opengl/shaders/Video.vert b/src/qmplay2/opengl/shaders/Video.vert
index 7ac052e1..0e1774ca 100644
--- a/src/qmplay2/opengl/shaders/Video.vert
+++ b/src/qmplay2/opengl/shaders/Video.vert
@@ -1,3 +1,4 @@
+// GLSL 1.20 for OpenGL 2.0
 attribute vec4 aPosition;
 attribute vec2 aTexCoord;
 varying vec2 vTexCoord;
diff --git a/src/qmplay2/opengl/shaders/VideoRGB.frag b/src/qmplay2/opengl/shaders/VideoRGB.frag
index 4dd4e1d8..2ec855e3 100644
--- a/src/qmplay2/opengl/shaders/VideoRGB.frag
+++ b/src/qmplay2/opengl/shaders/VideoRGB.frag
@@ -1,3 +1,4 @@
+// GLSL 1.20 for OpenGL 2.0
 #define texture texture2D
 
 varying vec2 vTexCoord;
diff --git a/src/qmplay2/opengl/shaders/VideoYCbCr.frag b/src/qmplay2/opengl/shaders/VideoYCbCr.frag
index 22cbac9f..5391dad4 100644
--- a/src/qmplay2/opengl/shaders/VideoYCbCr.frag
+++ b/src/qmplay2/opengl/shaders/VideoYCbCr.frag
@@ -1,3 +1,4 @@
+// GLSL 1.20 for OpenGL 2.0
 #ifdef TEXTURE_RECTANGLE
     #define sampler sampler2DRect
     #define texCoordY  (vTexCoord * uTextureSize)
diff --git a/src/qmplay2/vulkan/VulkanInstance.cpp b/src/qmplay2/vulkan/VulkanInstance.cpp
index 8d4196df..5867bbac 100644
--- a/src/qmplay2/vulkan/VulkanInstance.cpp
+++ b/src/qmplay2/vulkan/VulkanInstance.cpp
@@ -26,7 +26,7 @@
 #include "VulkanImagePool.hpp"
 #include "VulkanWriter.hpp"
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QVulkanInstance>
 #include <QVersionNumber>
 #include <QResource>
@@ -672,7 +672,7 @@ bool Instance::isCompatibleDevice(const shared_ptr<PhysicalDevice> &physicalDevi
     QString errorString = "Vulkan :: Discarding \"";
     errorString += properties.deviceName.data();
     errorString += "\", because:";
-    for (auto &&error : std::as_const(errors))
+    for (auto &&error : errors)
         errorString += "\n   - " + error;
     qDebug().noquote() << errorString;
 
diff --git a/src/qmplay2/vulkan/VulkanInstance.hpp b/src/qmplay2/vulkan/VulkanInstance.hpp
index afb24621..9a1eba4c 100644
--- a/src/qmplay2/vulkan/VulkanInstance.hpp
+++ b/src/qmplay2/vulkan/VulkanInstance.hpp
@@ -56,18 +56,18 @@ public:
     Instance();
     ~Instance();
 
-    void prepareDestroy() override;
+    void prepareDestroy();
 
 private:
     void init(bool doObtainPhysicalDevice);
 
 public:
-    QString name() const override;
-    QMPlay2CoreClass::Renderer renderer() const override;
+    QString name() const;
+    QMPlay2CoreClass::Renderer renderer() const;
 
-    VideoWriter *createOrGetVideoOutput() override;
+    VideoWriter *createOrGetVideoOutput();
 
-    bool checkFiltersSupported() const override;
+    bool checkFiltersSupported() const;
 
 public:
     inline QVulkanInstance *qVulkanInstance();
diff --git a/src/qmplay2/vulkan/VulkanWindow.cpp b/src/qmplay2/vulkan/VulkanWindow.cpp
index 3cf5843c..884c161f 100644
--- a/src/qmplay2/vulkan/VulkanWindow.cpp
+++ b/src/qmplay2/vulkan/VulkanWindow.cpp
@@ -40,7 +40,7 @@
 #include <Functions.hpp>
 #include <Sphere.hpp>
 
-#include <QGuiApplication>
+#include <QApplication>
 #include <QVulkanInstance>
 #include <QElapsedTimer>
 #include <qevent.h>
@@ -727,7 +727,7 @@ vector<unique_lock<mutex>> Window::prepareOSD(bool &changed)
     vector<unique_lock<mutex>> lockers;
     lockers.reserve(m_osd.size());
 
-    for (auto &&osd : std::as_const(m_osd))
+    for (auto &&osd : m_osd)
     {
         lockers.push_back(osd->lock());
 
@@ -793,7 +793,7 @@ void Window::renderOSD()
 
     vector<pair<const QMPlay2OSD::Image *, const QMPlay2OSD *>> osdImages;
 
-    for (auto &&osd : std::as_const(m_osd))
+    for (auto &&osd : m_osd)
     {
         osd->iterate([&](const QMPlay2OSD::Image &image) {
             if (image.dataBufferView->buffer()->device() != m.device)
diff --git a/src/qmplay2/vulkan/VulkanWindow.hpp b/src/qmplay2/vulkan/VulkanWindow.hpp
index 44116c0f..9147df3a 100644
--- a/src/qmplay2/vulkan/VulkanWindow.hpp
+++ b/src/qmplay2/vulkan/VulkanWindow.hpp
@@ -159,9 +159,9 @@ private:
     void resetSurface();
 
 private:
-    bool eventFilter(QObject *o, QEvent *e) override;
+    bool eventFilter(QObject *o, QEvent *e);
 
-    bool event(QEvent *e) override;
+    bool event(QEvent *e);
 
 private:
     const shared_ptr<HWInterop> &m_vkHwInterop;
diff --git a/src/qmplay2/vulkan/VulkanWriter.hpp b/src/qmplay2/vulkan/VulkanWriter.hpp
index 955396a7..94877d0f 100644
--- a/src/qmplay2/vulkan/VulkanWriter.hpp
+++ b/src/qmplay2/vulkan/VulkanWriter.hpp
@@ -37,24 +37,24 @@ public:
     Writer();
     ~Writer();
 
-    bool set() override;
+    bool set();
 
-    bool readyWrite() const override;
+    bool readyWrite() const;
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 
-    AVPixelFormats supportedPixelFormats() const override;
+    AVPixelFormats supportedPixelFormats() const;
 
-    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList) override;
+    void writeVideo(const Frame &videoFrame, QMPlay2OSDList &&osdList);
 
-    void pause() override;
+    void pause();
 
-    QString name() const override;
+    QString name() const;
 
-    bool open() override;
+    bool open();
 
-    bool setHWDecContext(const shared_ptr<HWDecContext> &hwDecContext) override;
-    shared_ptr<HWDecContext> hwDecContext() const override;
+    bool setHWDecContext(const shared_ptr<HWDecContext> &hwDecContext);
+    shared_ptr<HWDecContext> hwDecContext() const;
 
 private:
     Window *const m_window;
diff --git a/src/qmplay2/vulkan/VulkanYadifDeint.hpp b/src/qmplay2/vulkan/VulkanYadifDeint.hpp
index 538eaec6..a0aa5391 100644
--- a/src/qmplay2/vulkan/VulkanYadifDeint.hpp
+++ b/src/qmplay2/vulkan/VulkanYadifDeint.hpp
@@ -36,9 +36,9 @@ public:
     YadifDeint(const shared_ptr<HWInterop> &hwInterop);
     ~YadifDeint();
 
-    bool filter(QQueue<Frame> &framesQueue) override;
+    bool filter(QQueue<Frame> &framesQueue);
 
-    bool processParams(bool *paramsCorrected) override;
+    bool processParams(bool *paramsCorrected);
 
 private:
     bool ensureResources();
